Loading...
Searching...
No Matches
DiYBRPixelTemplate< T1, T2 > Class Template Reference

Template class to handle YCbCr pixel data. More...

Inheritance diagram for DiYBRPixelTemplate< T1, T2 >:

## Public Member Functions

| DiYBRPixelTemplate (const DiDocument *docu, const DiInputPixel *pixel, EI_Status &status, const unsigned long planeSize, const int bits, const OFBool rgb)
| constructor
virtual | ~DiYBRPixelTemplate ()
| destructor
Public Member Functions inherited from DiColorPixelTemplate< T2 >
| DiColorPixelTemplate (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor
virtual | ~DiColorPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation
const void * | getData () const
| get pointer to internal array of pixel data.
void * | getDataPtr ()
| get pointer to internal array of pixel data.
void * | getDataArrayPtr ()
| get pointer to internal array of pixel data.
OFBool | getPixelData (void *data, const unsigned long count, const unsigned long fcount, const unsigned long frames, const int planar) const
| fill given memory block with pixel data (all three image planes, RGB)
unsigned long | createDIB (void *&data, const unsigned long size, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits, const int mode, const int upsideDown, const int padding) const
| create true color (24/32 bit) bitmap for MS Windows.
unsigned long | createAWTBitmap (void *&data, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits) const
| create true color (32 bit) bitmap for Java (AWT default format).
Public Member Functions inherited from DiColorPixel
| DiColorPixel (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor
virtual | ~DiColorPixel ()
| destructor
int | getPlanes () const
| get number of planes
int | getPlanarConfiguration () const
| get planar configuration of the original pixel data
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element
Public Member Functions inherited from DiPixelRepresentationTemplate< T2 >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor

## Private Member Functions

void | convert (const T1 *pixel, const unsigned long planeSize, const int bits, const OFBool rgb)
| convert input pixel data to intermediate representation
void | convertValue (T2 &red, T2 &green, T2 &blue, const T2 y, const T2 cb, const T2 cr, const T2 maxvalue)
| convert a single YCbCr value to RGB

## Additional Inherited Members

Protected Member Functions inherited from DiColorPixelTemplate< T2 >
int | Init (const void *pixel)
| initialize internal memory
Protected Member Functions inherited from DiColorPixel
| DiColorPixel (const DiColorPixel *pixel, const unsigned long count)
| constructor
Protected Attributes inherited from DiColorPixelTemplate< T2 >
T2 * | Data [3]
| pointer to pixel data (3 components)
Protected Attributes inherited from DiColorPixel
int | PlanarConfiguration
| planar configuration of the original pixel data (0 = color-by-pixel, 1 = color-by-plane)
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer

## Detailed Description

template<class T1, class T2>
class DiYBRPixelTemplate< T1, T2 >

Template class to handle YCbCr pixel data.

## Constructor & Destructor Documentation

## DiYBRPixelTemplate()

template<class T1, class T2>

DiYBRPixelTemplate< T1, T2 >::DiYBRPixelTemplate | ( | const DiDocument * | docu,
|  | const DiInputPixel * | pixel,
|  | EI_Status & | status,
|  | const unsigned long | planeSize,
|  | const int | bits,
|  | const OFBool | rgb )

inline

constructor

Parameters

  docu | pointer to DICOM document
  pixel | pointer to input pixel representation
  status | reference to status variable
  planeSize | number of pixels in a plane
  bits | number of bits per sample
  rgb | flag, convert color model to RGB only if true

References DiColorPixelTemplate< T2 >::DiColorPixelTemplate(), convert(), DiPixel::Count, EIS_Normal, DiInputPixel::getData(), and DiInputPixel::getPixelStart().

## Member Function Documentation

## convert()

template<class T1, class T2>

void DiYBRPixelTemplate< T1, T2 >::convert | ( | const T1 * | pixel,
|  | const unsigned long | planeSize,
|  | const int | bits,
|  | const OFBool | rgb )

inline private

convert input pixel data to intermediate representation

Parameters

  pixel | pointer to input pixel data
  planeSize | number of pixels in a plane
  bits | number of bits per sample
  rgb | flag, convert color model to RGB only if true

References DiPixelRepresentationTemplate< T2 >::DiPixelRepresentationTemplate(), convertValue(), DiPixel::Count, DiColorPixelTemplate< T2 >::Data, DiColorPixelTemplate< T2 >::Init(), DiPixel::InputCount, DiPixelRepresentationTemplate< T >::isSigned(), DicomImageClass::maxval(), DiColorPixel::PlanarConfiguration, and OFBitmanipTemplate< T >::zeroMem().

Referenced by DiYBRPixelTemplate().

## convertValue()

template<class T1, class T2>

void DiYBRPixelTemplate< T1, T2 >::convertValue | ( | T2 & | red,
|  | T2 & | green,
|  | T2 & | blue,
|  | const T2 | y,
|  | const T2 | cb,
|  | const T2 | cr,
|  | const T2 | maxvalue )

inline private

convert a single YCbCr value to RGB

Parameters

  red | the red part of the RGB value
  green | the green part of the RGB value
  blue | the blue part of the RGB value
  y | the luma part of the YCbCr value
  cb | the blue-difference part of the YCbCr value
  cr | the red-difference part of the YCbCr value
  maxvalue | the maximum value of the RGB parts

Referenced by convert().

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/diybrpxt.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0